#include <stdio.h>
#include <iostream>
#include <string>
#include <cstdlib>
#include <set>
#include <assert.h>

#define si set<int>::iterator

using namespace std;

#define MAXNM 100000
#define MAXKS 100
#define MAXV 100
#define MODULE (1000*1000*1000)

void gentest()
{
	int n, m;
	do
	{
		n = rand()%MAXNM;
		m = rand()%MAXNM;
	}
	while(n == m);

	if (n > m)
	{
		swap(n, m);
	}
	cout << n << " " << m << endl;

	int k = rand() % MAXKS;
	cout << k << endl;
	for(int i=0; i<k; i++)
	{
		int v;
		do
		{
			v = rand() % MAXV;
		}
		while (v == 0);

		cout << v;
		if (i != k) cout << " ";		
	}
	cout << endl;

	int s = rand() % MAXKS;
	cout << s << endl;
	for(int i=0; i<s; i++)
	{
		int v;
		do
		{
			v = rand() % MAXV;
		}
		while (v < 2);

		cout << v;
		if (i != s) cout << " ";		
	}
	cout << endl;

}

void gentests(int count)
{
	for(int i=0; i<count; i++)
	{
		gentest();
	}
}

int main()
{
//	freopen("equalizer.in", "r", stdin);
//	freopen("equalizer.out", "w", stdout);
	
	int t;
	cin >> t;
	for(int test=0; test < t; test++)
	{
		int n, m;
		cin >> n >> m;
		assert(1 <= n && n <= MAXNM);
		assert(1 <= m && m <= MAXNM);
		assert(n < m);
		
		int an, bn;
		set<int> a, b;
		int am[MAXKS], bm[MAXKS];
		
		cin >> an;
		assert(0 <= an && an <= MAXKS);
		for(int i=0; i<an; i++)
		{
			int v;
			cin >> v;
			am[i] = v;
			assert(1 <= v && v <= MAXV);
			a.insert(v);			
		}
		
		cin >> bn;
		assert(0 <= bn && bn <= MAXKS);
		for(int i=0; i<bn; i++)
		{
			int v;
			cin >> v;
			bm[i] = v;
			assert(2 <= v && v <= MAXV);
			b.insert(v);			
		}
		
		long long ans[MAXNM+1024]={0};
		ans[n] = 1;
		
		for(int i=n; i<m; i++)
		{
			ans[i] %= MODULE;
			for(si k = a.begin(); k!=a.end(); k++)
			{
				int next = i+*k;
				if (next < m) ans[next]+=ans[i];
			}
			for(si s = b.begin(); s!=b.end(); s++)
			{
				int next = i*(*s);
				if (next <= m) ans[next]+=ans[i];
			}
		}
		
		cout << ans[m] % MODULE;
		cout << endl;
	}
	

	return 0;
}