#include <iostream>
#include <cstdio>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <stack>
#include <queue>
#include <vector>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <cstdlib>
#include <cassert>

using namespace std;
#define forn(i, n) for (int i = 0; i < n; ++i)
#define ALL(a) a.begin(), a.end()
#define X first
#define Y second
#define sz(a) ((int)a.size())
#define L(a) sz(a)
#define pb(a) push_back(a)
#define mp(a, b) make_pair(a, b)
#define ms(a) memset(a,0,sizeof(a))
#define ms1(a) memset(a,-1,sizeof(a))

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;

const double PI = 3.1415926535897932384626433832795;


const int maxn = 100000;
int nx[maxn];
int xx[maxn];
int val[maxn];

const int htsize = 1<<20;

vector<int> ord;

int head[htsize];

int findval(int x) {
	int hh = x&(htsize-1);
	for (int i = head[hh]; i != -1; i = nx[i]) if (xx[i] == x) return i;
	return -1;
}

int mem = 0;

void addvalue(int x, int v) {
	int hh = x&(htsize-1);
	ord.pb(hh);
	nx[mem] = head[hh];
	xx[mem] = x;
	val[mem] = v;
	head[hh] = mem++;
}

//map<int, int> mm;

int n;

int calc(ll x) {
	if (x >= n) return 0;
	//map<int,int>::iterator it = mm.find(x);
	int pos = findval((int)x);
	if (pos != -1) return val[pos];

	bool ok = 0;
	for (int i = 2; i <= 9; ++i) {
		ll to = x * i;
		if (!calc(to)) {
			addvalue(x, 1);
			return 1;
			//return mm[x] = 1;
		}
	}
	addvalue(x, 0);
	return 0;
	//return mm[x] = 0;
}

void solve() {
	mem = 0;
	scanf("%d", &n);
	forn(ii, sz(ord)) head[ord[ii]] = -1;
	ord.clear();
	int res = calc(1);
	if (res) printf("1\n");
	else printf("2\n");
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	/*freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);*/
#endif
	memset(head,-1,sizeof(head));
	int T; scanf("%d", &T); while (T--) solve();
	return 0;
}
