#include <iostream>
#include <vector>
#include <deque>
#include <set>
#include <cstdio>

using namespace std;

int Cnk(int n, int k)
{
	long long ans = 1;
	int a[10];

	for(int i = 0; i <k; i++){
		a[i] = n - k + 1 + i;
	}
	for(int i = 2; i< k; i++){
		int t= 0;
		while(a[t] % i != 0)
			t++;
		a[t] /= i;
	}
	
	for(int i = 0; i< k; i++)
		ans = ans * a[i] %2017;
	return ans;
}

int pow2(int n, int k)
{
	int t = 1;
	while(k){
		if(k & 1){
			t *= n;
			t %= 2017;
		}
		n*= n;
		n %= 2017;
		k >>= 1;
	}
	return t;
}

void solve()
{
	int n, k;
	cin >> n >> k;
	cout << (Cnk(n, k) * pow2(k, n-k) % 2017) << endl;
}

int main()
{
	int t;
	cin >> t;
	for(int i = 0; i < t; i++)
		solve();
	//cout << pow2(3, 3);
	cin >> t;
	return 0;
}