#include <iostream>
using namespace std;


const int max_n = 1e6;

int dp[max_n + 1];

int GetDp(int n)
{
    if (n <= max_n) {
        return dp[n];
    }

    for (int i = 2; i <= 9; ++i) {
        int k = n / i;
        if (k * i < n) {
            ++k;
        }

        if (GetDp(k) == 2) {
            return 1;
        }
    }
    return 2;
}

int main()
{
    ios_base::sync_with_stdio(false);

    dp[1] = 2;

    for (int i = 2; i <= max_n; ++i) {
        dp[i] = 2;
        for (int j = 2; j <= 9; ++j) {
            if (i >= j) {
                int k = i / j;
                if (k * j < i) {
                    ++k;
                }

                if (dp[k] == 2) {
                    dp[i] = 1;
                }
            }
        }
    }

    int tests;
    cin >> tests;
    for (int test = 0; test < tests; ++test) {
        int n;
        cin >> n;

        cout << GetDp(n) << endl;
    }


    return 0;
}
