#include <iostream>
#include <cstdio>
#include <set>
#include <map>
#include <queue>
#include <vector>
#include <fstream>
#include <sstream>
#include <algorithm>
#include <cassert>
#include <ctime>
#include <cmath>
#include <string>
#include <memory.h>
#include <unordered_map>

#define forn(i, n) for(int i = 0; i < (int)(n); ++i)
#define fore(i, a, b) for(int i = (int)(a); i <= (int)(b); ++i) 
#define for1(i, n) for(int i = 1; i <= (int)(n); ++i)
#define ford(i, n) for(int i = (int)(n) - 1; i >= 0; --i)
#define all(x) (x).begin(), (x).end()
#define mp make_pair
#define pb push_back
#define fi first
#define se second

using namespace std;

typedef long double ld;
typedef long long i64;
typedef vector<int> vi;
typedef vector<i64> vi64;
typedef pair<int, int> pii;
typedef unsigned int u32;
typedef vector<pii> vpi;

vector<i64> fibs;

i64 floor_div(i64 Y, i64 X) {
	assert( X > 0 );
	i64 r = Y / X;
	if( r * X > Y )
		r -= 1;
	return r;
}

void solve() {
	int n;
	cin >> n;
	pii ans((n+1)/2,n/2);
	forn(i, fibs.size() - 1) if(i) {
		i64 A = fibs[i], B = fibs[i + 1];
		i64 X, Y;
		if( i == 0 ) {
			X = 2; Y = -1;
		} else {
			X = fibs[i]; if( i & 1 ) X = -X;
			Y = -fibs[i-1]; if( i & 1 ) Y = -Y;
		}
		X *= n;
		Y *= n;
		i64 k = floor_div((Y-X), (A+B));
		X += B * k;
		Y -= A * k;
		if( X > 0 && Y > 0 && max(X,Y) <= 2e9 ) { 
			if( X <= Y ) ans = min(ans, pii(Y,X));
			else ans = min(ans, pii(X, Y));
		}
	}
	cout << ans.second << ' ' << ans.first << '\n';
}

int main() {
	fibs.pb(1);
	fibs.pb(1);
	while( fibs[fibs.size()-1] + fibs[fibs.size()-2] < 1.05e9 ) {
		fibs.pb( fibs[fibs.size()-1] + fibs[fibs.size()-2] );
	}
	cin.sync_with_stdio();
	cin.tie(0);
	cout.precision(12);
	cout << fixed;
	cerr.precision(12);
	cerr << fixed;
#ifdef HOME
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int T;
	cin >> T;
	forn(t, T) {
		solve();
	}
	return 0;
}
