#include <bits/stdc++.h>
using namespace std;

#ifdef SG
	#include "debug/debug.h"
#else
	#define show(...)
	#define debug(...)
	#define deepen(...)
	#define timer(...)
#endif

#define forn(i,n) for (int i = 0; i < int(n); ++i)
#define ford(i,n) for (int i = int(n) - 1; i >= 0; --i)
#define ve vector
#define pa pair
#define tu tuple
#define mp make_pair
#define mt make_tuple
#define pb push_back
#define fs first
#define sc second
#define all(a) (a).begin(), (a).end()
#define sz(a) ((int)(a).size())

typedef long double ld;
typedef long long ll;
typedef unsigned long long ull;
typedef unsigned int ui;
typedef unsigned char uc;
typedef pa<int, int> pii;
typedef pa<int, ll> pil;
typedef pa<ll, int> pli;
typedef pa<ll, ll> pll;
typedef ve<int> vi;

const ld pi = 3.1415926535897932384626433832795l;

template<typename T> inline auto sqr (T x) -> decltype(x * x) {return x * x;}
template<typename T> inline T abs (T x) {return x > T() ? x : -x;}
template<typename T1, typename T2> inline bool umx (T1& a, T2 b) {if (a < b) {a = b; return 1;} return 0;}
template<typename T1, typename T2> inline bool umn (T1& a, T2 b) {if (b < a) {a = b; return 1;} return 0;}

struct Input {
	string a, b;
	
	bool read () {
		return cin >> a >> b;
	}

	void init (const Input &input) {
		*this = input;
	}
};

struct Data: Input {
	ve<string> ans;
	string res;
	
	void print (string s, int mx) {
		forn (i, mx - sz(s)) {
			printf(" ");
		}
		cout << s << "\n";
	}
	
	void print (string s, int mx, int e) {
		forn (i, mx - sz(s) - e) {
			printf(" ");
		}
		cout << s;
		forn (i, e) {
			printf(" ");
		}
		printf("\n");
	}
	
	void printDash (int x, int mx) {
		forn (i, mx - x) {
			printf(" ");
		}
		forn (i, x) {
			printf("-");
		}
		printf("\n");
	}
	
	void write (int x) {
		printf("Test %d\n", x);
		int mx = 0;
		forn (i, sz(ans)) {
			mx = max(mx, sz(ans[i]) + i);
		}
		mx = max(mx, sz(res));
		print(a, mx);
		print(b, mx);
		int e = max(sz(a), sz(b));
		printDash(e, mx);
		forn (i, sz(ans)) {
			print(ans[i], mx, i);
		}
		printDash(mx, mx);
		print(res, mx);
	}
	
	virtual void solve () {}
	
	virtual void clear () {
		*this = Data();
	}
};

struct Solution: Data {
	string toString (ll x) {
		if (x == 0) {
			return "0";
		}
		
		string res = "";
		while (x > 0) {
			if (x & 1) {
				res += '1';
			}
			else {
				res += '0';
			}
			x /= 2;
		}
		reverse(all(res));
		return res;
	}
	
	ll toInt (string x) {
		ll res = 0;
		forn (i, sz(x)) {
			res *= 2;
			res += (x[i] - '0');
		}
		return res;
	}
	
	void solve () {
		string z;
		forn (i, sz(a)) {
			z += "0";
		}
		ford (i, sz(b)) {
			if (b[i] == '0') {
				ans.pb(z);
			}
			else {
				ans.pb(a);
			}
		}
		
		res = toString(toInt(a) * toInt(b));
	}
	
	void clear () {
		*this = Solution();
	}
};

Solution sol;

int main () {
	cout.setf(ios::showpoint | ios::fixed);
	cout.precision(20);
#ifdef SG
	freopen("b.in", "r", stdin);
//	freopen("output.txt", "w", stdout);
#else
//	freopen("", "r", stdin);
//	freopen("", "w", stdout);
#endif
	int t;
	cin >> t;
	forn (i, t) {
		sol.read();
		sol.solve();
		sol.write(i + 1);
		printf("\n");
		sol.clear();
	}
	return 0;
}
