#include <bits/stdc++.h>
using namespace std;

#ifdef SG
	#include "debug/debug.h"
#else
	#define show(...)
	#define debug(...)
	#define deepen(...)
	#define timer(...)
#endif

#define forn(i,n) for (int i = 0; i < int(n); ++i)
#define ford(i,n) for (int i = int(n) - 1; i >= 0; --i)
#define ve vector
#define pa pair
#define tu tuple
#define mp make_pair
#define mt make_tuple
#define pb push_back
#define fs first
#define sc second
#define all(a) (a).begin(), (a).end()
#define sz(a) ((int)(a).size())

typedef long double ld;
typedef long long ll;
typedef unsigned long long ull;
typedef unsigned int ui;
typedef unsigned char uc;
typedef pa<int, int> pii;
typedef pa<int, ll> pil;
typedef pa<ll, int> pli;
typedef pa<ll, ll> pll;
typedef ve<int> vi;

const ld pi = 3.1415926535897932384626433832795l;

template<typename T> inline auto sqr (T x) -> decltype(x * x) {return x * x;}
template<typename T> inline T abs (T x) {return x > T() ? x : -x;}
template<typename T1, typename T2> inline bool umx (T1& a, T2 b) {if (a < b) {a = b; return 1;} return 0;}
template<typename T1, typename T2> inline bool umn (T1& a, T2 b) {if (b < a) {a = b; return 1;} return 0;}

const int N = 110;

struct Input {
	int n;
	int a[N];
	
	bool read () {
		if (scanf ("%d", &n) !=1 )
			return 0;
		forn(i, n) {
			scanf ("%d", &a[i]);
		}
		return 1;
	}

	void init (const Input &input) {
		*this = input;
	}
};

struct Data: Input {
	int ans;
	
	void write () {
		cout << ans << endl;
	}
	
	virtual void solve () {}
	
	virtual void clear () {
		*this = Data();
	}
};

struct Solution: Data {

	int f (int a) {
		if (a == 0) {
			return 0;
		}
		int s = 0;
		while (a > 0) {
			if ((a % 10) != 0)
				s++;
			a /= 10;
		}
		return s;
	}

	int g(int a) {
		if (a == 0) {
			return 0;
		}
		int kol = 0;
		while (a > 0) {
			a /= 10;
			kol++;
		}
		return kol;	
	}
	
	int t[10];
	
	void solve () {
		ans = 0;
		if (n == 0) {
			return;
		}
		t[0] = 1;
		for (int i = 1; i < 10; ++i) {
			t[i] = t[i - 1] * 10;
	 	}
	 	ll bst = 1000000000000000000ll;	
	 	forn(i, 10) {
	 		ll help = 0;
    		forn(j, n) {
    			help += f(a[j] % t[i]);	
    			ll k = a[j] / t[i];
    			help += (k + 8) / 9;
    		}
    		bst = min(bst, i + help);
		}
		ans = bst;
	}
	
	void clear () {
		*this = Solution();
	}
};

Solution sol;

int main () {
	cout.setf(ios::showpoint | ios::fixed);
	cout.precision(20);
#ifdef SG
	freopen("input.txt", "r", stdin);
//	freopen("output.txt", "w", stdout);
	int t;
	cin >> t;
	forn(i, t) {
		sol.read();
		sol.solve();
		sol.write();
		sol.clear();
	}
#else
//	freopen("", "r", stdin);
//	freopen("", "w", stdout);
	int t;
	cin >> t;
	forn(i, t) {
		sol.read();
		sol.solve();
		sol.write();
		sol.clear();
	}
	#endif

	return 0;
}
