#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <ctime>
#include <cstring>
#include <algorithm>
#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <queue>
#include <deque>
using namespace std;
#define pb push_back
#define mp make_pair
#define sc second
#define fs first
#define int64 long long
#define ldb long double
#define sz(a) ((int) (a).size())
#define eprintf(...) fprintf(stderr, __VA_ARGS__)

const int size = 100;

int tc, n, m;
char num1[size];
char num2[size];

void printspaces(int k) {
	for (int i = 0; i < k; i++)
		printf(" ");
}

void printzeroes(int k) {
	for (int i = 0; i < k; i++)
		printf("0");
}

void printdashes(int k) {
	for (int i = 0; i < k; i++)
		printf("-");
}

int main() {
	//assert(freopen("input.txt", "r", stdin));
	//assert(freopen("output.txt", "w", stdout));

	scanf("%d", &tc);
	for (int tnum = 0; tnum < tc; tnum++) {
		if (tnum > 0)
			printf("\n");
		scanf("%s%s", num1, num2);
		n = strlen(num1);
		m = strlen(num2);

		long long v1 = 0, v2 = 0;
		for (int i = 0; i < n; i++) {
			v1 = v1 * 2 + (num1[i] - '0');
		}
		for (int i = 0; i < m; i++) {
			v2 = v2 * 2 + (num2[i] - '0');
		}

		long long res = v1 * v2;
		int hl = 0;
		long long h = res;
		while (h > 0) {
			hl++;
			h /= 2;
		}
		hl = max(hl, 1);
		int tot = n + m - 1;
		
		tot = max(hl, tot);

		char buf[100];
		for (int i = 0; i <= tot; i++)
			buf[i] = 0;
		for (int i = tot - 1; i >= 0; i--) {
			buf[i] = char('0' + res % 2);
			res /= 2;
		}
		bool flag = false;
		for (int i = 0; i < tot - 1; i++) {
			flag = flag || (buf[i] == '1');
			if (!flag)
				buf[i] = ' ';
		}

		printf("Test %d\n", tnum + 1);
		printspaces(tot - n);
		printf("%s\n", num1);
		printspaces(tot - m);
		printf("%s\n", num2);
		printspaces(tot - max(n, m));
		printdashes(max(n, m));
		printf("\n");
		for (int i = 0; i < m; i++) {
			printspaces(tot - n - i);
			if (num2[m - 1 - i] == '1')
				printf("%s\n", num1);
			else {
				printzeroes(n);
				printf("\n");
			}
		}
		printdashes(tot);
		printf("\n");

		printf("%s\n", buf);
	}

	return 0;
}