#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <ctime>
#include <cstring>
#include <algorithm>
#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <queue>
#include <deque>
using namespace std;
#define pb push_back
#define mp make_pair
#define sc second
#define fs first
#define int64 long long
#define ldb long double
#define sz(a) ((int) (a).size())
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
const int LIMIT = 10000;
const int STOP = 100;

int color[LIMIT + 1], tc, n;

int main() {
	//assert(freopen("input.txt", "r", stdin));
	//assert(freopen("output.txt", "w", stdout));
	scanf("%d", &tc);
	for (int it = 0; it < tc; ++it) {
		for (int i = 0; i <= LIMIT; ++i)
			color[i] = -1;
		scanf("%d", &n);
		int l = n, r = (int) 2e9, c = 0;
		while (l >= STOP) {
			for (int i = l; i <= min(r, LIMIT); ++i)
				color[i] = c;
			if (c == 0) {
				c = 1, r = l - 1, l = (l + 8) / 9;
			} else {
				c = 0, r = l - 1, l = (l + 1) / 2;
			}
		}
		for (int i = n; i <= LIMIT; ++i)
			color[i] = 0;
		for (int i = min(n - 1, LIMIT); i >= 1; --i)
			if (color[i] == -1) {
				assert(i * 9 <= LIMIT);
				color[i] = 0;
				for (int j = 2; j <= 9; ++j)
					if (color[i * j] == 0) {
						color[i] = 1;
						break;
					}
			}
		printf("%d\n", 2 - color[1]);
	}
	return 0;
}