#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <stack>
#include <queue>
#include <deque>
#include <complex>

using namespace std;

#define pb push_back
#define mp make_pair
#define sz(s) int((s).size())
#define len(s) int((s).size())
#define all(s) (s).begin(), (s).end()
#ifdef _WIN32
#define LLD "%I64d"
#else
#define LLD "%lld"
#endif
#ifdef LOCAL42
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) 42
#endif
#define y0 yy0
#define y1 yy1
#define next _next
#define prev _prev
#define rank _rank
#define link _link
#define hash _hash
#define fs first
#define sc second

typedef long long ll;
typedef long long llong;
typedef long long int64;
typedef unsigned int uint;
typedef long double ld;
typedef unsigned long long ull;
typedef unsigned long long ullong;
typedef unsigned long long lint;
typedef pair<int, int> pii;
typedef vector<int> vi;

const int inf = int(1e9);
const double eps = 1e-9;
const double pi = 4 * atan(double(1));

const int MOD = 2017;

int powmod(int x, int k)
{
	x %= MOD;
	int ans = 1;
	while (k)
	{
		if (k & 1)
			ans = (ans * x) % MOD;
		k >>= 1;
		x = (x * x) % MOD;
	}
	return ans;
}

int inv(int x)
{
	return powmod(x, MOD - 2);
}

const int N = 12;

int C[N][N];
int IF[N], F[N];

int D[N];

void solve()
{
	int n, k;
	scanf("%d %d", &n, &k);
	D[0] = 1;
	for (int i = 1; i <= k; i++)
	{
		D[i] = powmod(i, n);
		for (int j = 1; j < i; j++)
			D[i] = ((MOD * MOD + D[i] - D[j] * C[i][j] % MOD * F[j] % MOD) % MOD + MOD) % MOD;
		D[i] = (D[i] * IF[i]) % MOD;
	}
	printf("%d\n", D[k]);
}

int main() {
#ifdef LOCAL42
#define TASK "K"
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
#else

#endif
	int T;
	scanf("%d", &T);

	for (int n = 0; n < N; n++)
	{
		C[n][0] = C[n][n] = 1;
		for (int k = 1; k < n; k++)
			C[n][k] = (C[n - 1][k - 1] + C[n - 1][k]) % MOD;
	}

	IF[0] = F[0] = 1;
	for (int n = 1; n < N; n++)
		IF[n] = (IF[n - 1] * inv(n)) % MOD, F[n] = F[n - 1] * n % MOD;

	for (int i = 0; i < T; i++)
		solve();
	return 0;
}
