#include <iostream>
#include <fstream>
#include <ctime>
#include <cstdio>
#include <vector>
#include <map>
#include <algorithm>
#include <set>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <bitset>
#include <deque>
#include <stack>
#include <queue>
using namespace std;

#define fs first
#define sc second

#define pb push_back
#define mp make_pair

#define forn(i, n) for(int i = 0; i < (int)n; ++i)
#define all(x) (x).begin(), (x).end()

const int MAXN = 205;
char used[MAXN];
vector<int> g[MAXN];

int dfs(int v) {
    used[v] = true;
    int res = 1;
    for(size_t i = 0; i < g[v].size(); i++)
        if(!used[g[v][i]])
            res += dfs(g[v][i]);
    return res;
}

int main()
{
    ios_base::sync_with_stdio(false);
    int t;
    cin >> t;
    for(int tt = 0; tt < t; tt++) {
        int n, m;
        cin >> n >> m;
        for(int i = 0; i < n; i++)
            g[i].clear();
        for(int i = 0; i < m; i++) {
            int v, u;
            cin >> v >> u;
            v--;
            u--;
            g[v].push_back(u);
            g[u].push_back(v);
        }
        int ans = MAXN;
        for(int i = 0; i < n; i++)
            used[i] = false;
        for(int i = 0; i < n; i++)
            if(!used[i])
                ans = min(ans, dfs(i));
        cout << ans << '\n';
    }
    return 0;
}
