#include <iostream>
#include <fstream>
#include <ctime>
#include <cstdio>
#include <vector>
#include <map>
#include <algorithm>
#include <set>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <bitset>
#include <deque>
#include <stack>
#include <queue>
using namespace std;

#define fs first
#define sc second

#define pb push_back
#define mp make_pair

#define forn(i, n) for(int i = 0; i < (int)n; ++i)
#define all(x) (x).begin(), (x).end()

const int MAXN = 100 * 1000 + 5, INF = 1000 * 1000 * 1000 + 5;
int a[MAXN], n, k;

bool check(long long t) {
    long long res = 0;
    for(int i = 0; i < n; i++)
        res += t / a[i];
    if(res >= k)
        return true;
    return false;
}

int main()
{
    ios_base::sync_with_stdio(false);
    int t;
    cin >> t;
    for(int tt = 0; tt < t; tt++) {
        cin >> n >> k;
        for(int i = 0; i < n; i++)
            cin >> a[i];
        long long l = 0, r = (long long)INF * INF;
        while(l < r - 1) {
            long long m = (l + r) / 2;
            if(check(m))
                r = m;
            else
                l = m;
        }
        cout << r << '\n';
    }
    return 0;
}
