#include <stdio.h>
#include <string.h>
#include <math.h>

#include <algorithm>
#include <string>
#include <map>
#include <unordered_map>
#include <set>
#include <vector>
#include <queue>
#include <deque>
#include <iostream>

using namespace std;

int t, n;
int v[100005], aib[100005], sol[100005];

void update (int poz)
{
    while (poz <= n)
    {
        aib[poz] ++;
        poz += poz & -poz;
    }
}

int query (int poz)
{
    int sol = 0;
    while (poz > 0)
    {
        sol += aib[poz];
        poz -= poz & -poz;
    }
    return sol;
}

int main ()
{
#ifdef local
    freopen ("c.in", "r", stdin);
    freopen ("c.out", "w", stdout);
#endif

    scanf ("%d", &t);
    while (t --)
    {
        int i;
        memset (aib, 0, sizeof (aib));
        scanf ("%d", &n);
        for (i = 1; i <= n; i ++)
            scanf ("%d", &v[i]);
        for (i = n; i >= 1; i --)
        {
            sol[i] = query (v[i]);
            update (v[i]);
        }
        for (i = 1; i <= n; i ++)
            printf ("%d ", sol[i]);
        printf ("\n");
    }
    return 0;
}
