#include <iostream>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <cstring>
#include <cstdio>
#include <ctime>
#include <cassert>
#include <vector>
#include <queue>
#include <cmath>

#define fr first
#define sc second
#define mp make_pair
#define pb push_back 

using namespace std;

const int N = 1e3 + 10;
const int INF = 1e9;

bool use[N];
vector < int > e[N];
int dist[N];
int p[N];
queue < int > q;


int main() {
#ifdef DEBUG
	freopen("in", "r", stdin);
#endif
	int T;
	scanf("%d", &T);
	for (int tt = 0; tt < T; tt++) {
		int n, m;
		scanf("%d%d", &n, &m);
		for (int i = 0; i < n; i++)
			e[i].clear();
		for (int i = 0; i < m; i++) {
			int v, u;
			scanf("%d%d", &v, &u); v--; u--;
			e[v].pb(u);
			e[u].pb(v);
		}
		int ans = INF;
		for (int i = 0; i < n; i++) {
			memset(dist, 63, sizeof(dist));
			q.push(i);
			dist[i] = 0;
			while (!q.empty()) {
				int v = q.front();
				q.pop();
				for (int u: e[v]) {
					if (dist[u] < INF && p[v] != u) {
						ans = min(ans, dist[v] + 1 + dist[u]);
					}

					if (dist[u] > dist[v] + 1) {
						dist[u] = dist[v] + 1;
						p[u] = v;
						q.push(u);
					}
				}
			}
			break;
		}
		printf("%d\n", ans);
	}

	return 0;
}

