#include<cstdlib>

#include<iostream>
#include<fstream>
#include<sstream>

#include<vector>
#include<string>
#include<set>
#include<map>

#include<cmath>
#include<algorithm>
#include<limits>

using namespace std;

#define fi(i, a, b) for (int i = a; i < b; i++)

int a[100001];

struct Segment{
	int l,r;
	vector<int> sorted;
	Segment(int left, int right){
		l = left; r = right;
		fi(i,l,r) sorted.push_back(a[i]);
		sort(sorted.begin(), sorted.end());
	}
	int get(int aa, int b, int x){
		if(aa<=l && b >=r) return (lower_bound(sorted.begin(), sorted.end(), x) - sorted.begin());
		else{
			int sum=0;
			for(int i = max(l,aa); i < min(r,b);i++){
				if(a[i]<x) sum++;
			}
			return sum;
		}
	}
};

vector<Segment*> t;

int main()
{
#if defined (DEBUG) || defined (_DEBUG)
	ifstream cin("input.txt");
	ofstream cout("output.txt");
#endif

	int tests;
	cin>>tests;
	fi(tt,0,tests){
		t.clear();
		int n;
		cin>>n;

		fi(i,0,n) cin>>a[i];

		int k = ceil(sqrt((double)n));

		for(int i = 0; i < n; i+=k)
			t.push_back(new Segment(i,min(i+k,n)));

		fi(i,0,n){
		int cur=0;
		fi(j,0,t.size())
			cur+=t[j]->get(i+1,n,a[i]);
		cout<<cur<<" ";
		}
	}

	return 0;
}