#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <vector>
#include <string>
#include <ctime>
#include <queue>
#include <map>
#include <set>

#ifdef WIN32
    #define I64 "%I64d"
#else
    #define I64 "%lld"
#endif // WIN32

#define next(x) (x + ((x) & (-x)))
#define prev(x) (x - ((x) & (-x)))
#define N 2002
#define md 1000000007
#define sqr(x) ((x) * (x))
#define INF (1 << 30)
#define EPS 0.00000001

using namespace std;
long long n, t, k;
vector<long long> a;

long long check(long long x) {
    long long result = 0;
    for (int i = 0; i < a.size(); i++) {
        if (result < k) {
            result +=  x / a[i];
        }
    }
    return result;
}

int main() {
    #ifdef DEBUG
        freopen("input.txt", "r", stdin);
        //freopen("output.txt", "w", stdout);
    #else
        //freopen("input.txt", "r", stdin);
        //freopen("output.txt", "w", stdout);
    #endif // DEBUG

    srand(time(NULL));
    cin >> t;
    for (int i = 0; i < t; i++) {
        cin >> n >> k;
        a.clear();
        for (int j = 0; j < n; j++) {
            long long x;
            cin >> x;
            a.push_back(x);
        }
        long long l = 0;
        long long r = 100000000000;
        while(l < r) {
            long long mid = (l + r) / 2;
            if (check(mid) < k) {
                l = mid + 1;
            } else {
                r = mid;
            }
        }
        cout << r << endl;
    }

    return 0;
}
