#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define sz(x) ((int) (x).size())
#define pb push_back
#define mp make_pair
#define fi first
#define se second
#define y1 retyuhfr
#define y0 kdjflkdsajfldsakjflkdsajflw

#define NAME "i"
#define long long long
#define M 200

void euclid(long a, long b, long &x, long &y)
{
	if (a == 0)
	{
		x = 0, y = 1;
		return;
	}
	if (b == 0)
	{
		x = 1, y = 0;
		return;
	}
	
	long x1, y1;
	euclid(b % a, a, x1, y1);
	y = x1;
	x = y1 - (b / a) * x1;
	assert(a * x + b * y == 1);
}

long f[M], b, a;

void pre()
{
	f[0] = 0;
	f[1] = 1;
	for (int i = 2; i < M; ++i)
		f[i] = f[i - 1] + f[i - 2];
}

void relax(long aa, long bb)
{
	if (b > bb || (b == bb && a > aa))
	{
		a = aa;
		b = bb;
	}
}

void kill()
{
	long n;
	cin >> n;
	a = 1;
	b = n - 1;
	for (int i = 2; f[i] <= n; ++i)
	{
		long x0, y0;
		long a = f[i - 2];
		long b = f[i - 1];
		
		euclid(a, b, x0, y0);
		
		x0 *= n;
		y0 *= n;
		
		long k = (y0 - x0) / (a + b);
		while (y0 - x0 >= (k + 1) * (a + b))
			++k;
		while (y0 - x0 < k * (a + b))
			--k;
		if (x0 + k * b > 0)
			relax(x0 + k * b, y0 - k * a);
	}
	cout << a << " " << b << "\n";
}

int main()
{
	#ifdef LOCAL
	assert(freopen(NAME ".in", "r", stdin));
	#endif // LOCAL
	int t;
	cin >> t;
	pre();
	while (t--)
		kill();
	#ifdef LOCAL
	cerr << "Time: " << double(clock()) / CLOCKS_PER_SEC << "\n";
	#endif // LOCAL
	return 0;
}
