#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cassert>

#include <iostream>
#include <iomanip>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <deque>
#include <queue>
#include <stack>
#include <algorithm>


#define forn(i, n) for(int i = 0; i < int(n); i++)
#define mp make_pair
#define pb push_back
#define foreach(it, v) for(__typeof(v.begin()) it = v.begin(); it != v.end(); ++it)

using namespace std;

typedef long long ll;


int main() {
	ios_base::sync_with_stdio(false);
	int tests;
	cin >> tests;
	for(int test = 0; test < tests; test++) {
		int n, k;
		cin >> n >> k;
		vector < ll > times(n);
		for(int i = 0; i < n; i++)
			cin >> times[i];
		typedef pair < ll, int > state_t;
		priority_queue < state_t > q;
		for(int i = 0; i < n; i++) {
			q.push(mp(-times[i], i));
		}
		ll result = 0;
		for(int i = 0; i < k; i++) {
			state_t state = q.top();
			q.pop();
			result = -state.first;
			q.push(mp(-result - times[state.second], state.second));
		}
		cout << result << endl;
	}
	return 0;
}