#include <iostream>
#include <set>
using namespace std;

const int max_n = 1e5;

int a[max_n];
int n;

int ans[max_n];

int t[max_n];

void Clear()
{
    for (int i = 0; i < n; ++i) {
        t[i] = 0;
    }
}

int GetAmount(int pos)
{
    int result = 0;
    for (; pos >= 0; pos = (pos & (pos + 1)) - 1) {
        result += t[pos];
    }
    return result;
}

void SetValue(int pos, int val)
{
    for (; pos < n; pos |= (pos + 1)) {
        t[pos] += val;
    }
}

int main()
{
    ios_base::sync_with_stdio(false);

    int tests;
    cin >> tests;
    for (int test = 0; test < tests; ++test) {
        cin >> n;
        for (int i = 0; i < n; ++i) {
            cin >> a[i];
            --a[i];
        }

        Clear();

        for (int i = n - 1; i >= 0; --i) {
            if (a[i] == 0) {
                ans[i] = 0;
            } else {
                ans[i] = GetAmount(a[i] - 1);
            }
            SetValue(a[i], 1);
        }

        for (int i = 0; i < n; ++i) {
            cout << ans[i] << " ";
        }

        cout << endl;
    }

    return 0;
}
