#include <cstdio>
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <memory.h>
#include <queue>
#include <deque>
#include <stack>
#include <list>
#include <map>
#include <set>
#include <functional>
#include <cstring>
#include <ctime>

using namespace std;

#define all(a) a.begin(), a.end()
#define mp make_pair

typedef long long li;
typedef long double ld;
typedef pair<int, int> pi;
typedef vector<int> vi;

#define FILENAME ""

void solve();
int main() {
#ifdef YA
	string s = FILENAME;
	//assert(!s.empty());
	clock_t start = clock();
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	//freopen(FILENAME ".in", "r", stdin);
	//freopen(FILENAME ".out", "w", stdout);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	cout.sync_with_stdio(0);
	cin.tie(0);
	cout.precision(15);
	cout << fixed;

	int t = 1;
	cin >> t;
	while(t--) {
		solve();
	}
#ifdef YA
	cout << "\n\n" << (clock() - start) / 1.0 / CLOCKS_PER_SEC << "\n\n";
#endif
	return 0;
}


//#define int li

int n;
int p[100500];

const int shift = 1<<17;

int tree[2 * shift + 5];

int order[100500];

void modify(int v) {
	v += shift;
	tree[v] = 1;
	v /= 2;
	while(v > 0) {
		tree[v] = tree[2 * v] + tree[2 * v + 1];
		v /= 2;
	}
}

int sum(int l, int r) {
	if (l >= r)
		return 0;
	if (l & 1)
		return tree[l] + sum(l + 1, r);
	if (r & 1)
		return tree[r - 1] + sum(l, r - 1);
	return sum(l / 2, r / 2);
}

int getSum(int l, int r) {
	return sum(l + shift, r + shift);
}

void solve() {
	memset(tree, 0, sizeof tree);
	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> p[i];
		--p[i];
		order[p[i]] = i;
	}

	vector<int> res(n);

	for (int i = 0; i < n; ++i) {
		res[order[i]] = getSum(order[i], n);
		modify(order[i]);
	}

	for (int i = 0; i < n; ++i)
		cout << res[i] << ' ';
	cout << "\n";

}