#include <iostream>
#include <algorithm>
#include <cstring>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <string>
#include <vector>
#include <map>
#include <queue>
#include <stack>
#include <iomanip>

using namespace std;

const int MAX_N = 100005;

int n, a[MAX_N], ans[MAX_N], f[MAX_N];

void update(int x) {
    for (int i = x + 1; i <= n; i += (i & -i)) {
        f[i]++;
    }
}

int query(int x) {
    int ans = 0;

    for (int i = x + 1; i > 0; i -= (i & -i)) {
        ans += f[i];
    }

    return ans;
}

int main() {
    cin.sync_with_stdio(false);
    cout.sync_with_stdio(false);

    /*
    freopen("task.in", "r", stdin);
    freopen("task.out", "w", stdout);
    */

    int tests;

    cin >> tests;

    for (int test = 0; test < tests; test++) {
        cin >> n;

        for (int i = 0; i < n; i++) {
            cin >> a[i];
            a[i]--;
        }

        memset(f, 0, sizeof(f));
        for (int i = n - 1; i >= 0; i--) {
            ans[i] = query(a[i]);
            update(a[i]);
        }

        for (int i = 0; i < n; i++) {
            cout << ans[i] << " ";
        }

        cout << endl;
    }

    return 0;
}
