#include <iostream>
#include <cstdio>
#include <set>
#include <map>
#include <queue>
#include <vector>
#include <fstream>
#include <sstream>
#include <algorithm>
#include <cassert>
#include <ctime>
#include <cmath>
#include <string>
#include <memory.h>
#include <unordered_map>

#define forn(i, n) for(int i = 0; i < (int)(n); ++i)
#define fore(i, a, b) for(int i = (int)(a); i <= (int)(b); ++i) 
#define for1(i, n) for(int i = 1; i <= (int)(n); ++i)
#define ford(i, n) for(int i = (int)(n) - 1; i >= 0; --i)
#define all(x) (x).begin(), (x).end()
#define mp make_pair
#define pb push_back
#define fi first
#define se second

using namespace std;

typedef long double ld;
typedef long long i64;
typedef vector<int> vi;
typedef vector<i64> vi64;
typedef pair<int, int> pii;
typedef unsigned int u32;
typedef vector<pii> vpi;

int n, m, b;
bool a[40][40];
int ans;
int cans;

bool can(int i, int j, int h, int w) {
	if( i + h - 1 < n && j + w - 1 < m ) {
		fore(p, 0, h-1) fore(q, 0, w-1)
			if( a[i + p][j + q] )
				return false;
		return true;
	} else return false;
}

void go(int i, int j, int h, int w) {
	++cans;
	fore(p, 0, h-1) fore(q, 0, w-1)
		a[i + p][j + q] = 1;
}

void ungo(int i, int j, int h, int w) {
	--cans;
	fore(p, 0, h-1) fore(q, 0, w-1)
		a[i + p][j + q] = 0;
}


void f(int i, int j) {
	if( j == m ) f(i + 1, 0);
	else if( i == n ) {
		ans = max(ans, cans);
	} else {
		/*
		int cfans1 = 0;
		forn(p, n) forn(q, m) if( mp(p, q) >= mp(i, j) ) {
			if( can(p, q, 3, 4) || can(p, q, 4, 3) )
				++cfans1;
		}
		int cfans2 = 0;
		forn(p, n) forn(q, m) if( mp(p, q) >= mp(i, j) ) {
			if( !a[p][q] )
				++cfans2;
		}
		cfans2 /= 12;
		if( cans + cfans1 <= ans ) {
			return ;
		}
		if( cans + cfans2 <= ans ) {
			return ;
		}
		*/
		if( can(i, j, 3, 4) ) {
			go(i, j, 3, 4);
			f(i, j + 1);
			ungo(i, j, 3, 4);

		}
		if( can(i, j, 4, 3) ) {
			go(i, j, 4, 3);
			f(i, j + 1);
			ungo(i, j, 4, 3);
		}
		f(i, j+1);
	}
}

void solve() {
	cin >> n >> m >> b;
	forn(i, n) forn(j, m) a[i][j] = 0;
	forn(i, n) forn(j, m) if( i == 0 || j == 0) a[i][j] = 1;
	forn(e, b) {
		int x, y, w, h;
		cin >> x >> y >> w >> h;
		//x = max(x-1, 0);
		//y = max(y-1, 0);
		++w; ++h;
		fore(p, 0, h-1) fore(q, 0, w-1)
			a[x + p][y + q] = 1;
	}
	ans = 0;
	f(0,0);
	cout << ans << '\n';
}

int main() {
	cin.sync_with_stdio();
	cin.tie(0);
	cout.precision(12);
	cout << fixed;
	cerr.precision(12);
	cerr << fixed;
#ifdef HOME
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int T;
	cin >> T;
	forn(t, T) {
		solve();
	}
	return 0;
}
