#include <bits/stdc++.h>
using namespace std;

#ifdef SG
	#include "debug/debug.h"
#else
	#define show(...)
	#define debug(...)
	#define deepen(...)
	#define timer(...)
#endif

#define forn(i,n) for (int i = 0; i < int(n); ++i)
#define ford(i,n) for (int i = int(n) - 1; i >= 0; --i)
#define ve vector
#define pa pair
#define tu tuple
#define mp make_pair
#define mt make_tuple
#define pb push_back
#define fs first
#define sc second
#define all(a) (a).begin(), (a).end()
#define sz(a) ((int)(a).size())

typedef long double ld;
typedef long long ll;
typedef unsigned long long ull;
typedef unsigned int ui;
typedef unsigned char uc;
typedef pa<int, int> pii;
typedef pa<int, ll> pil;
typedef pa<ll, int> pli;
typedef pa<ll, ll> pll;
typedef ve<int> vi;

const ld pi = 3.1415926535897932384626433832795l;

template<typename T> inline auto sqr (T x) -> decltype(x * x) {return x * x;}
template<typename T> inline T abs (T x) {return x > T() ? x : -x;}
template<typename T1, typename T2> inline bool umx (T1& a, T2 b) {if (a < b) {a = b; return 1;} return 0;}
template<typename T1, typename T2> inline bool umn (T1& a, T2 b) {if (b < a) {a = b; return 1;} return 0;}

const int N = 10;

struct Input {
	int n, m;
	bool a[N][N];
	
	bool read () {
		if (!(cin >> n >> m)) {
			return 0;
		}
		memset(a, 0, sizeof a);
		int k;
		cin >> k;
		forn (i, k) {
			int x, y, dx, dy;
			scanf("%d%d%d%d", &x, &y, &dx, &dy);
			forn (di, dx) {
				forn (dj, dy) {
					a[x + di][y + dj] = 1;
				}
			}
		}
		return 1;
	}

	void init (const Input &input) {
		*this = input;
	}
};

struct Data: Input {
	int ans;
	
	void write () {
		cout << ans << endl;
	}
	
	virtual void solve () {}
	
	virtual void clear () {
		*this = Data();
	}
};

struct Solution: Data {
	int u1[N][N], u2[N][N];
	int cur;
	
	void calc (int i, int j) {
		if (i + 2 >= n) {
			umx(ans, cur);
			return;
		}
		if (j + 2 >= m) {
			calc(i + 1, 1);
			return;
		}
		if (cur + ((n - i - 1) * m + m - j) / 12 <= ans) {
			return;
		}
		if (!u1[i][j]) {
			for (int di = -2; di <= 2; ++di) {
				for (int dj = -3; dj <= 3; ++dj) {
					if (i + di >= 0 && i + di < n && j + dj >= 0 && j + dj < m) {
						u1[i + di][j + dj]++;
					}
				}
			}
			for (int di = -3; di <= 2; ++di) {
				for (int dj = -2; dj <= 3; ++dj) {
					if (i + di >= 0 && i + di < n && j + dj >= 0 && j + dj < m) {
						u2[i + di][j + dj]++;
					}
				}
			}
			++cur;
			calc(i, j + 1);
			--cur;
			for (int di = -3; di <= 2; ++di) {
				for (int dj = -2; dj <= 3; ++dj) {
					if (i + di >= 0 && i + di < n && j + dj >= 0 && j + dj < m) {
						u2[i + di][j + dj]--;
					}
				}
			}
			for (int di = -2; di <= 2; ++di) {
				for (int dj = -3; dj <= 3; ++dj) {
					if (i + di >= 0 && i + di < n && j + dj >= 0 && j + dj < m) {
						u1[i + di][j + dj]--;
					}
				}
			}
		}
		if (!u2[i][j]) {
			for (int di = -3; di <= 3; ++di) {
				for (int dj = -2; dj <= 2; ++dj) {
					if (i + di >= 0 && i + di < n && j + dj >= 0 && j + dj < m) {
						u2[i + di][j + dj]++;
					}
				}
			}
			for (int di = -2; di <= 3; ++di) {
				for (int dj = -3; dj <= 2; ++dj) {
					if (i + di >= 0 && i + di < n && j + dj >= 0 && j + dj < m) {
						u1[i + di][j + dj]++;
					}
				}
			}
			++cur;
			calc(i, j + 1);
			--cur;
			for (int di = -2; di <= 3; ++di) {
				for (int dj = -3; dj <= 2; ++dj) {
					if (i + di >= 0 && i + di < n && j + dj >= 0 && j + dj < m) {
						u1[i + di][j + dj]--;
					}
				}
			}
			for (int di = -3; di <= 3; ++di) {
				for (int dj = -2; dj <= 2; ++dj) {
					if (i + di >= 0 && i + di < n && j + dj >= 0 && j + dj < m) {
						u2[i + di][j + dj]--;
					}
				}
			}
		}
		calc(i, j + 1);
	}
	
	void solve () {
		memset(u1, 0, sizeof u1);
		memset(u2, 0, sizeof u2);
		ans = 0;
		forn (i, n) {
			forn (j, m) {
				if (i > 0 && j > 0 && i + 2 < n && j + 3 < m) {
					bool ok = 1;
					for (int di = -1; di <= 2; ++di) {
						for (int dj = -1; dj <= 3; ++dj) {
							ok &= !a[i + di][j + dj];
						}
					}
					if (!ok) {
						u1[i][j] = 1;
					}
				} else {
					u1[i][j] = 1;
				}
			}
		}
		forn (i, n) {
			forn (j, m) {
				if (i > 0 && j > 0 && i + 3 < n && j + 2 < m) {
					bool ok = 1;
					for (int di = -1; di <= 3; ++di) {
						for (int dj = -1; dj <= 2; ++dj) {
							ok &= !a[i + di][j + dj];
						}
					}
					if (!ok) {
						u2[i][j] = 1;
					}
				} else {
					u2[i][j] = 1;
				}
			}
		}
		cur = 0;
		calc(1, 1);
	}
	
	void clear () {
		*this = Solution();
	}
};

Solution sol;

int main () {
	cout.setf(ios::showpoint | ios::fixed);
	cout.precision(20);
#ifdef SG
	freopen("j.in", "r", stdin);
//	freopen("output.txt", "w", stdout);
#else
//	freopen("", "r", stdin);
//	freopen("", "w", stdout);
#endif
	int t;
	cin >> t;
	forn (i, t) {
		sol.read();
		sol.solve();
		sol.write();
		sol.clear();
	}
	return 0;
}
