#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <ctime>
#include <cstring>
#include <algorithm>
#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <queue>
#include <deque>
using namespace std;
#define pb push_back
#define mp make_pair
#define sc second
#define fs first
#define int64 long long
#define ldb long double
#define sz(a) ((int) (a).size())
#define eprintf(...) fprintf(stderr, __VA_ARGS__)

const int size = 200 * 1000;
const long long inf = (long long)1e14 + 100;

int tc, n, k;
int t[size];

bool check(long long val) {
	long long sum = 0;
	for (int i = 0; i < n; i++) {
		sum += (val) / t[i];
		if (sum >= k)
			break;
	}

	return sum >= k;
}

int main() {
	//assert(freopen("input.txt", "r", stdin));
	//assert(freopen("output.txt", "w", stdout));

	scanf("%d", &tc);
	for (int tnum = 0; tnum < tc; tnum++) {
		scanf("%d%d", &n, &k);
		for (int i = 0; i < n; i++)
			scanf("%d", &t[i]);
		sort(t, t + n);
		long long lb = 1;
		long long rb = inf;
		while (lb < rb) {
			long long mid = (lb + rb) / 2;
			if (check(mid))
				rb = mid;
			else
				lb = mid + 1;
		}

		printf("%lld\n", lb);
	}

	return 0;
}