#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <ctime>
#include <cstring>
#include <algorithm>
#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <queue>
#include <deque>
using namespace std;
#define pb push_back
#define mp make_pair
#define sc second
#define fs first
#define int64 long long
#define ldb long double
#define sz(a) ((int) (a).size())
#define eprintf(...) fprintf(stderr, __VA_ARGS__)

const int inf = 1000 * 1000 * 1000;
const int size = 1000;

int tc, n;
int a[size];

int could(int num, int k) {
	int ans = 0;
	while (num > 0 && k > 0) {
		if (num % 10) {
			num -= num % 10;
			ans++;
		}
		num /= 10;
		k--;
	}
	ans += (num + 8) / 9;

	return ans;
}

int main() {
	//assert(freopen("input.txt", "r", stdin));
	//assert(freopen("output.txt", "w", stdout));

	scanf("%d", &tc);
	for (int tnum = 0; tnum < tc; tnum++) {
		scanf("%d", &n);
		for (int i = 0; i < n; i++)
			scanf("%d", &a[i]);
		long long best = inf;
		for (int i = 0; i <= 10; i++) {
			long long cur = 0;
			for (int j = 0; j < n; j++)
				cur += could(a[j], i);
			best = min(best, cur + i);
		}

		printf("%lld\n", best);
	}

	return 0;
}