#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <stack>
#include <queue>
#include <deque>
#include <complex>

using namespace std;

#define pb push_back
#define mp make_pair
#define sz(s) int((s).size())
#define len(s) int((s).size())
#define all(s) (s).begin(), (s).end()
#ifdef _WIN32
#define LLD "%I64d"
#else
#define LLD "%lld"
#endif
#ifdef LOCAL42
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) 42
#endif
#define y0 yy0
#define y1 yy1
#define next _next
#define prev _prev
#define rank _rank
#define link _link
#define hash _hash
#define fs first
#define sc second

typedef long long ll;
typedef long long llong;
typedef long long int64;
typedef unsigned int uint;
typedef long double ld;
typedef unsigned long long ull;
typedef unsigned long long ullong;
typedef unsigned long long lint;
typedef pair<int, int> pii;
typedef vector<int> vi;

const int inf = int(1e9);
const double eps = 1e-9;
const double pi = 4 * atan(double(1));

int pt = 0;

const int N = 60;

int F[N];

void solve()
{
	int n;
	scanf("%d", &n);
	pair<llong, llong> ans((llong)1e17, (llong)1e17);
	for (int k = 1; k < pt; k++)
	{
		llong a = F[k + 1], b = -F[k];
		if (a * F[k - 1] + b * F[k] != 1)
			a = -a, b = -b;
		assert(a * F[k - 1] + b * F[k] == 1);
		a *= n, b *= n;
		if (b < 0)
		{
			llong r = (-b + F[k - 1] - 1) / F[k - 1];
			b += r * F[k - 1];
			a -= r * F[k];
			if (a <= 0)
				continue;
		}
		else
		{
			llong r = b / F[k - 1];
			b -= r * F[k - 1];
			a += r * F[k];
			if (a <= 0)
				continue;
		}
		llong w;
		if (a <= b)
			w = 0;
		else
			w = (a - b + F[k] + F[k - 1] - 1) / (F[k] + F[k - 1]);
		b += F[k - 1] * w;
		a -= F[k] * w;
		if (a <= 0)
			continue;
		ans = min(ans, make_pair(b, a));
	}
	printf("%d %d\n", (int)ans.second, (int)ans.first);
}

int main() {
#ifdef LOCAL42
#define TASK "I"
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
#else

#endif

	F[0] = F[1] = 1;
	for (pt = 2; ; )
	{
		F[pt] = F[pt - 1] + F[pt - 2];
		if (F[pt] > inf + 42)
			break;
		pt++;
		assert(pt < N);
	}

	int T;
	scanf("%d", &T);
	for (int i = 0; i < T; i++)
		solve();
	return 0;
}
