#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <bitset>
#include <sstream>
#include <cstdio>
#include <cstring>
#include <cmath>
#include <climits>
#include <cctype>
#include <cstdlib>
using namespace std;

#define FOR(i,a,b) for(int i=(a);i<(b);i++)
#define ROF(i,a,b) for(int i=(b)-1;i>=(a);i--)
#define REOPEN(i,o) do{freopen(i,"rt",stdin);freopen(o,"wt",stdout);}while(0)

typedef long long LL;
typedef LL ll;
typedef pair<int, int> pii;
const int INF = 1000000000;
const LL LINF = 1000000000000000000LL;
const double PI = 3.1415926535897932384626433832795;

pii gett(int n) {
  pii ans(0, 0);
  while (n) {
    if (n > 10 && n <= 18) {
      n = 0;
      ans.first += 2;
    } else if (n % 10) {
      n -= n % 10;
      ans.first++;
    } else {
      n /= 10;
      ans.second++;
    }
  }
  return ans;
}

int main() {
  int T;
  cin >> T;
  FOR(i, 0, T) {
    int N; cin >> N;
    pii ans(0, 0);
    FOR(j, 0, N) {
      int a; cin >> a;
      pii c = gett(a);
      ans.first += c.first;
      ans.second = max(ans.second, c.second);
    }
    cout << ans.first + ans.second << "\n";
  }
  return 0;
}
