#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <bitset>
#include <sstream>
#include <cstdio>
#include <cstring>
#include <cmath>
#include <climits>
#include <cctype>
#include <cstdlib>
using namespace std;

#define FOR(i,a,b) for(int i=(a);i<(b);i++)
#define ROF(i,a,b) for(int i=(b)-1;i>=(a);i--)
#define REOPEN(i,o) do{freopen(i,"rt",stdin);freopen(o,"wt",stdout);}while(0)

typedef long long LL;
typedef LL ll;
typedef pair<int, int> pii;
const int INF = 1000000000;
const LL LINF = 1000000000000000000LL;
const double PI = 3.1415926535897932384626433832795;

const int NUM = 44;
LL mp[NUM][4] = {{0, 1, 1, 1}};

LL gcd(LL a, LL b, LL& x, LL& y) {
  if (b == 0) {
    x = 1;
    y = 0;
    return a;
  }
  LL x1, y1;
  LL d = gcd(b, a % b, x1, y1);
  x = y1;
  y = x1 - (a / b) * y1;
  return d;
}

void test() {
  LL n; cin >> n;
  pii best(1, n - 1);
  FOR(i, 1, NUM) {
    LL a = mp[i][0], b = mp[i][1];
    LL x, y;
    LL d = gcd(a, b, x, y);
    if (n % d) continue;
    x *= (n / d);
    y *= (n / d);
    LL p = b / d, q = a / d;
    LL k = (y - x);
    if (k >= 0) k /= (p + q);
    else k = -((-k) + p + q - 1) / (p + q);
    x += k * p;
    y -= k * q;
    if (x < 1) continue;
    if (y < best.second || (y == best.second && x == best.first)) {
      best = pii(x, y);
    }
  }
  cout << best.first << " " << best.second << "\n";
}

int main() {
  FOR(i, 1, NUM) {
    mp[i][0] = mp[i - 1][2];
    mp[i][1] = mp[i - 1][3];
    mp[i][2] = mp[i - 1][0] + mp[i - 1][2];
    mp[i][3] = mp[i - 1][1] + mp[i - 1][3];
  }
  int T;
  cin >> T;
  FOR(i, 0, T) test();
  return 0;
}
