#include <iostream>
#include <fstream>
#include <ctime>
#include <cstdio>
#include <vector>
#include <map>
#include <algorithm>
#include <set>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <bitset>
#include <deque>
#include <stack>
#include <queue>
using namespace std;

#define fs first
#define sc second

#define pb push_back
#define mp make_pair

#define forn(i, n) for(int i = 0; i < (int)n; ++i)
#define all(x) (x).begin(), (x).end()

long long gcd(long long a, long long b)
{
    return b ? gcd(b, a % b) : a;
}

pair<int, int> extGcd(long long a, long long b) {
    if(!b)
        return make_pair(1, 0);
    pair<int, int> p = extGcd(b, a % b);
    return make_pair(p.second, p.first - (a / b) * p.second);
}

vector <int> fib;

int main()
{
    ios_base::sync_with_stdio(false);
    fib.pb(1);
    fib.pb(1);
    while(1)
    {
        int ln = fib.size();
        fib.pb(fib[ln - 2] + fib[ln - 1]);
        if(fib.back() > 1000000000)
        {
            fib.pop_back();
            break;
        }
    }
    int t;
    cin >> t;
    forn(tt, t)
    {
        int n;
        cin >> n;
        for(int i = fib.size() - 1; i - 1 >= 0; --i)
        {
            if(n % gcd(fib[i], fib[i - 1]) != 0)
                continue;
            else
            {
                pair<long long, long long> ans = extGcd(fib[i - 1], fib[i]);
                ans.first *= n / gcd(fib[i], fib[i - 1]);
                ans.second *= n / gcd(fib[i], fib[i - 1]);
                if(ans.first < 0)
                {
                    long long g = gcd(fib[i - 1], fib[i]);
                    long long tv1 = fib[i] / g;
                    long long tv2 = fib[i - 1] / g;
                    long long add;
                    long long tv = ans.first * (-1);
                    add = (tv + tv1 - 1) / tv1;
                    ans.first += add * tv1;
                    ans.second -= add * tv2;
                }
                if(ans.first > 0 && ans.second > 0)
                {
                    if(ans.first <= ans.second)
                        cout << ans.first << " " << ans.second << endl;
                    else
                        cout << ans.second << " " << ans.first + ans.second << endl;
                    break;
                }
            }
        }
    }
    return 0;
}
