#include <algorithm>
#include <cassert>
#include <cmath>
#include <complex>
#include <cstdio>
#include <cstring>
#include <iostream>
#include <map>
#include <set>
#include <string>
#include <sstream>
#include <vector>
using namespace std;

typedef pair<int, int> ii;
typedef vector<int> vi;
typedef vector<ii> vii;
typedef vector<vector<int> > vvi;
typedef long long ll;
template <class T> int size(const T& x) {return x.size();}

const double EPS = 1e-9;
const int INF = 2147483647;

int main() {
    int ts;
    scanf("%d\n", &ts);
    for (int t = 0; t < ts; t++) {
        int n;
        scanf("%d\n", &n);
        if (n <= 9) {
            cout << 1 << endl;
            continue;
        }

        if (n / (9.0 * pow(18, floor(log(n) / log(18.0)))) < 1)  {
            cout << 1 << endl;
        }else {
            cout << 2 << endl;
        }
    }

    return 0;
}
