#define _USE_MATH_DEFINES

#include <cstdio>
#include <iostream>
#include <string>
#include <cstring>
#include <cstdlib>
#include <iomanip>
#include <vector>
#include <queue>
#include <map>
#include <set>
#include <stack>
#include <bitset>
#include <algorithm>
#include <ctime>
#include <cassert>
#include <cmath>

using namespace std;

#define forn(i, n) for (int i = 0; i < int(n); ++i)
#define pb push_back
#define mp make_pair
#define sz(a) int(a.size())
#define all(a) a.begin(),a.end()

typedef long long li;
typedef long double ld;

typedef pair<int,int> pt;
#define ft first
#define sc second

const int INF = int(1e9);
const li INF64 = li(1e18);
const ld EPS = 1e-9;

//#define TASK_NAME ""

const int N = 1000 * 1000 + 5;

int n, k, t[N];

bool read() {
	if (scanf("%d %d", &n, &k) != 2)
		return false;
	forn(i, n)
		scanf("%d", &t[i]);
	return true;
}

bool can(li m) {
	li res = 0;
	forn(i, n) {
		res += m / t[i];
		if (res >= k)
			return true;
	}
	return res >= k;
}

void solve() {
	li l = 0, r = li(1e18) + 300;
	while (r - l > 1) {
		li m = (l + r) >> 1;
		if (can(m))
			r = m;
		else
			l = m;
	}

	for (li i = l; i <= r; ++i)
		if (can(i)) {
			printf("%I64d\n", i);
			return;
		}

	assert(false);
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else

#ifdef TASK_NAME
	freopen(TASK_NAME ".in", "r", stdin);
	freopen(TASK_NAME ".out", "w", stdout);
#endif

#endif

	int t;
	scanf("%d", &t);

	forn(i, t) {
		assert(read());
		solve();
	}

	return 0;
}