#include <iostream>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <cstring>
#include <cstdio>
#include <ctime>
#include <cassert>
#include <vector>
#include <queue>
#include <cmath>

#define fr first
#define sc second
#define mp make_pair
#define pb push_back 

using namespace std;

const int N = 1e6 + 10;
const int INF = 1e9;

int n, K;
int a[N];

bool check(int t) {
	long long sum = 0;
	for (int i = 0; i < n; i++) {
		sum += t / a[i];
		if (sum > INF) return 1;
	}
	return sum >= K;
}



int main() {
#ifdef DEBUG
	freopen("in", "r", stdin);
#endif
	int T;
	scanf("%d", &T);
	for (int tt = 0; tt < T; tt++) {
		scanf("%d%d", &n, &K);
		int mn = INF;
		for (int i = 0; i < n; i++) {
			scanf("%d", &a[i]);
			mn = min(a[i], mn);
		}
		long long l = 0;
		long long r = K * mn;
		while (r - l > 1) {
			if (check((l + r) / 2))
				r = (l + r) / 2;
			else
				l = (l + r) / 2;
		}
		printf("%I64d\n", r);
	}
	return 0;
}

