#include <iostream>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <cstring>
#include <cstdio>
#include <ctime>
#include <cassert>
#include <vector>
#include <queue>
#include <cmath>

#define fr first
#define sc second
#define mp make_pair
#define pb push_back 

using namespace std;

const int N = 1e6 + 10;
const int INF = 1e9;

int n, k;
int a[N];
int tt;

int main() {
#ifdef DEBUG
	freopen("in", "r", stdin);
#endif
        scanf("%d", &tt);
        while (tt--) {
        	scanf("%d%d", &n, &k);
        	for (int i = 0; i < n; i++) scanf("%d", &a[i]);
        	long long ll = 0, rr = 1e18;
        	while (ll < rr - 1) {
        		long long mid = (ll + rr) / 2;
        		long double sum = 0;
        		for (int i = 0; i < n; i++) {
        			sum += mid / a[i];
        		}
        		if (sum >= k) rr = mid;
        		else ll = mid;
        	}
        	cout << rr << endl;
        }
	return 0;
}

